﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports System.Diagnostics


Namespace ReplyAllContextMenu2007_2010
    'Add-in Express Add-in Module
    <GuidAttribute("09B66049-25AD-48E3-99C0-BC21C575DC37"), ProgIdAttribute("ReplyAllContextMenu2007-2010-vb.AddinModule")> _
    Public Class AddinModule
        Inherits AddinExpress.MSO.ADXAddinModule

        Friend WithEvents adxOutlookEvents As AddinExpress.MSO.ADXOutlookAppEvents
#Region " Component Designer generated code. "
        'Required by designer
        Private components As System.ComponentModel.IContainer

        'Required by designer - do not modify
        'the following method
        Private Sub InitializeComponent()
            Me.components = New System.ComponentModel.Container
            Me.adxOutlookEvents = New AddinExpress.MSO.ADXOutlookAppEvents(Me.components)
            '
            'adxOutlookEvents
            '
            '
            'AddinModule
            '
            Me.AddinName = "ReplyAllContextMenu2007-2010-vb"
            Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook

        End Sub

#End Region

#Region " Add-in Express automatic code "

        'Required by Add-in Express - do not modify
        'the methods within this region

        Public Overrides Function GetContainer() As System.ComponentModel.IContainer
            If components Is Nothing Then
                components = New System.ComponentModel.Container
            End If
            GetContainer = components
        End Function

        <ComRegisterFunctionAttribute()> _
        Public Shared Sub AddinRegister(ByVal t As Type)
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
        End Sub

        <ComUnregisterFunctionAttribute()> _
        Public Shared Sub AddinUnregister(ByVal t As Type)
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
        End Sub

        Public Overrides Sub UninstallControls()
            MyBase.UninstallControls()
        End Sub

#End Region

        Public Sub New()
            MyBase.New()

            Application.EnableVisualStyles()
            'This call is required by the Component Designer
            InitializeComponent()

            'Please add any initialization code to the AddinInitialize event handler

        End Sub

        Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
            Get
                Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
            End Get
        End Property

        Public ReadOnly Property OutlookApp() As Outlook._Application
            Get
                Return CType(HostApplication, Outlook._Application)
            End Get
        End Property

        Private replyAllChecker As ReplyAllChecker = Nothing

        Private Sub AddinModule_AddinStartupComplete(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.AddinStartupComplete
            Debug.Print("The AddinStartupComplete event has occured.")
            Debug.Print("The add-in has been loaded by Outlook " & Me.HostMajorVersion.ToString())

            ' This creates an item of the class that handles the events of an Outlook item
            ReplyAllChecker = New ReplyAllChecker(Me)
        End Sub

        Private Sub AddinModule_AddinBeginShutdown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.AddinBeginShutdown
            ' in Outlook 2010, this event may not occur, see the blog 'Outlook 2010 Fast Shutdown feature'
            ' at http://www.add-in-express.com/creating-addins-blog/2010/05/04/outlook2010-fast-shutdown/

            Debug.Print("The AddinBeginShutdown event has occured.")

            If ReplyAllChecker.IsConnected Then
                Debug.Print("Disconnecting replyAllChecker from the previously connected item.")
                ReplyAllChecker.RemoveConnection()
            End If
            ReplyAllChecker = Nothing
        End Sub

        Private Sub ConnectToSelectedItem(ByVal selection As Outlook.Selection)
            If selection IsNot Nothing Then
                If selection.Count = 1 Then
                    Dim item As Object = selection.Item(1)
                    If TypeOf item Is Outlook.MailItem Then
                        If replyAllChecker.IsConnected Then
                            Debug.Print("Disconnecting replyAllChecker from the previously connected item.")
                            replyAllChecker.RemoveConnection()
                        End If
                        Debug.Print("Connecting replyAllChecker to this Outlook item.")
                        replyAllChecker.ConnectTo(item, True)
                    Else
                        Marshal.ReleaseComObject(item)
                        Debug.Print("Do not connect to this Outlook item.")
                    End If
                End If
            End If
        End Sub

        Private Sub adxOutlookEvents_ItemContextMenuDisplay(ByVal sender As System.Object, ByVal commandBar As System.Object, ByVal target As System.Object) Handles adxOutlookEvents.ItemContextMenuDisplay
            Debug.Print("The ItemContextMenuDisplay event has occured.")
            Try
                Dim selection As Outlook.Selection = TryCast(target, Outlook.Selection)
                If selection IsNot Nothing Then
                    ConnectToSelectedItem(selection)
                    Marshal.ReleaseComObject(selection)
                Else
                    Debug.Print("No items are selected.")
                End If
            Catch
            End Try
        End Sub
    End Class
End Namespace

